void NManip::ScaZ(void)
{
    const COld *fin;
    COld fout;
    NOlm::IterateD fiter;

    vector<CCoord> TabCo;
    vector<char>   TabSt; // status
    CList TabSel, TestList;
    string   breaktext="";
    bool     breakcoord;
    uint     i, ii, j, jj, maxscan;
    string action;

    //** make coord table 
    fiter.Reset();
    while( (fin=fiter()) ) {
        for( i=0; i<fin->ZCo.size(); ++i ){
            for( ii=0; ii<TabCo.size(); ++ii )
                if( fin->ZCo[i]==TabCo[ii] ) goto oldzco;
            TabCo.push_back( fin->ZCo[i] );
            TabSt.push_back('d');
        oldzco: ;
        }
    }
	
    //** find maxscan 
    maxscan = 0;
    fiter.Reset();
    while((fin=fiter()))
        maxscan = max(maxscan, fin->nScan());

        //** set status of z coordinates
    while(1) {

        //** display table
        printf("Status of z coordinates:"
               " d(elete a(verage b(reakpoint\n");
        breakcoord = 0;
        for (ii=0; ii<TabCo.size(); ++ii) {
            printf(" %3d [%c] %s\n", 
                   ii, TabSt[ii], TabCo[ii].str().c_str());
            if (TabSt[ii]=='b') breakcoord = 1;
        }
        if (breakcoord) {
            breaktext = "";
            printf("Breakpoints according to coordinates\n");
        } else if (breaktext!="") {
            printf("Breakpoints: %s\n", breaktext.c_str());
        } else {
            printf("Default breakpoints: 0 for A/M, * for B\n");
        }

        //** user action
    ask_action:
        action = sask( "Action", "h" );
        if        ( action=="q" ) {
            return;
        } else if ( action=="d" || action=="a" || action=="b" ) {
            TabSel.Ask( "Set status of coordinate no.", 0, TabCo.size()-1 );
            for( int iv=0; iv<TabSel.n(); ++iv )
                TabSt[ TabSel.V[iv] ] = action[0];
        } else if ( action=="s" ) {
            breaktext = wask("Enter list of breakpoints");
            if (breaktext=="") break;
            TestList = CList(breaktext, 0, maxscan-1);
            if (!TestList.contained(0)) {
                printf("! breakpoints must include 0\n");
                break;
            }
            for (ii=0; ii<TabCo.size(); ++ii)
                if (TabSt[ii]=='b') TabSt[ii]='d';
        } else if ( action=="A" || action=="M" || action=="B" ) {
            goto execute;
        } else {
            if (action!="h")
                cout << mystd::BEL;
            printf("possible actions:\n"
                   "   d a b    change status of coordinates\n"
                   "   s        set list of breakpoints\n"
                   "   A M      average / merge scans\n"
                   "   B        break one file into several\n");
            goto ask_action;
        } 
    }

    //** call execute routines
 execute:

    string docline;

    fiter.Reset();
    NOlm::SelNew();
    while ((fin=fiter())) {

        fout = *fin;
        fout.VS.clear();
        fout.ZCo.clear();

        if (fin->nScan()<=0) {
            printf("!! Empty file\n");
            return;
        }

        //** get coordinate status
        vector<char> CoSt(fin->ZCo.size());
        for (i=0; i<fin->ZCo.size(); ++i) {
            for (ii=0; ii<TabCo.size(); ++ii)
                if (fin->ZCo[i]==TabCo[ii]) goto entryfound;
            printf("!!! PROG ERR: coord not found\n");
            return;
        entryfound:
            CoSt[i] = TabSt[ii];
        }

        //** get break points
        CList BP;
        if (breakcoord) {
            vector<double> Z(fin->ZCo.size());
            Z = fin->VS[0].z;
            BP = CList((uint) 0);
            for (j=1; j<fin->nScan(); ++j) {
                for (i=0; i<fin->ZCo.size(); ++i) {
                    if (CoSt[i]=='b' && 
                        fin->VS[j].z[i]!=Z[i]) {
                        Z[i] = fin->VS[j].z[i];
                        BP += CList(j);
                    }
                }
            }
        } else if (breaktext!="") {
            BP = CList(breaktext, 0, fin->nScan()-1 );
        } else if (action=="B") {
            BP = CList (0, fin->nScan()-1);
        } else {
            BP = CList ((uint) 0);
        }

        //** generate z coordinates
        for (i=0; i<fin->ZCo.size(); ++i) {
            if        (CoSt[i]!='d') {
                fout.ZCo.push_back(fin->ZCo[i]);
            } 
        }
		
        //** docline
        if        ( action=="A" ) {
            docline = "average scans";
        } else if ( action=="M" ) {
            docline = "merge scans";
        } else if ( action=="B" ) {
            docline = "break file into several";
        } else
            throw string( "PROG ERROR invalid action" );
        docline += " breakpoints [" + BP.str() + "]";
        fout.lDoc.push_back(docline);

        //** new scans, set z
        for (j=0; j<fin->nScan(); ++j) {
            if (!BP.contained(j)) continue;
            CScan S;
            for (i=0; i<fin->ZCo.size(); ++i) {
                if        (CoSt[i]=='b') {
                    S.z.push_back(fin->VS[j].z[i]);
                } else if (CoSt[i]=='a') {
                    double zav = fin->VS[j].z[i];
                    uint nav = 1;
                    for (jj=j+1; jj<fin->nScan() && 
                             !BP.contained(jj); ++jj) {
                        zav += fin->VS[jj].z[i];
                        ++nav;
                    }
                    S.z.push_back(zav/nav);
                }
            }
            fout.VS.push_back(S);
        }
		
        //** act on x,y
        if        ( action=="A" ) {
            ScaExeAvge( fin, &fout, BP );
        } else if ( action=="M" ) {
            ScaExeMerge( fin, &fout, BP );
        } else if ( action=="B" ) {
            ScaExeBreak( fin, fout, BP );
        } else
            throw string( "PROG ERROR invalid action" );

        NOlm::OloAdd(&fout);
    }
}

void NManip::ScaExeAvge( const COld *fin, COld *fout, const CList& BP )
{
    uint iv, ji, jf, jj, i, n, mj;
    vector<double> y;
    string err;
    CScan *Sout;

    for(iv=0; iv<BP.n(); iv++) {
        ji = BP.V[iv];
        jf = ( iv<BP.n()-1 ? BP.V[iv+1] : fin->nScan() );
        // printf("DEBUG iv=%u ji=%u jf=%u\n", iv, ji, jf);
        Sout = &(fout->VS[iv]);
        n = fin->VS[ji].size();
        for (jj=ji; jj<jf; ++jj) {
            if ( fin->VS[jj].size() != fin->VS[ji].size() )
                throw "scan " + strg(jj) + " has other size than scan 0";
            for( uint i=0; i<fin->VS[jj].size(); ++i )
            if ( fin->VS[jj].x[i] != fin->VS[ji].x[i] )
                throw "scan " + strg(jj) + " has other x[" + strg(i) +
                    " than scan 0";
        }
        // printf("DEBUG n=%u\n", n);
        Sout->x = fin->VS[ji].x;
        y.assign(n,0.);
        mj = jf-ji;
        // printf("DEBUG mj=%u\n", mj);
        for (jj=ji; jj<jf; jj++)
            for (i=0; i<n; i++)
                y[i] += fin->VS[jj].y[i] / mj;
        Sout->y = y;
    }
}

void NManip::ScaExeMerge( const COld *fin, COld *fout, const CList& BP )
{
    uint j, jj, jout, i;
    CScan *Sout;

    for (j=0, jout=0; j<fin->nScan(); ++j) {
        if (!BP.contained(j)) continue;
        Sout = &(fout->VS[jout++]);
        for (jj=j; jj<fin->nScan() && !(jj>j && BP.contained(jj)); ++jj)
            for (i=0; i<fin->VS[jj].size(); ++i)
                Sout->push_back(fin->VS[jj].x[i],
                                fin->VS[jj].y[i]);
    }
}

void NManip::ScaExeBreak( const COld *fin, const COld& ftmp, const CList& BP )
{
    COld fout;
    uint j;

    for (j=0; j<fin->nScan(); ) {
        // if (!BP.contained(j)) continue;
        fout = ftmp;
        fout.VS.clear();
        do {
            fout.VS.push_back(fin->VS[j++]);
        } while (j<fin->nScan() && !BP.contained(j));
        NOlm::OloAdd(&fout);
    }
}
